UPM.define("AddonModel",["jquery","underscore","brace","AddonActions","AddonPricingModel","AddonReviewModel","AddonWatchingModel","ExpandableModelMixin","UpmAjax","UpmAnalytics","UpmContextPathMixin","UpmEnvironment","UpmMessageModel","UpmPricing"],function(F,M,K,L,I,J,N,C,A,E,G,B,H,D){return K.Model.extend({mixins:[G,C],namedAttributes:["billingNotifications","dataCenterCompatible","statusDataCenterCompatible","description","hamsProductKey","installedVersion","hasDetails","key","licenseDetails","links","logo","name","restartState","usesLicensing","vendor","version"],canReview:function(){return !!this.getLinkOrPacResponseLink("plugin-review")
},canWatchOrUnwatch:function(){return !!this.getLinkOrPacResponseLink("plugin-watch")
},focus:function(P){var O=F.Deferred();
this.once("focused",function(){O.resolve()
});
this.trigger("focus",this,P);
return O.promise()
},isActionAllowed:function(P){var O=this.getActionState(P);
return(M.isObject(O)&&O.enabled)||O
},isLicenseUpdatable:function(){var O=this.getLinks();
return O&&O["update-license"]
},getActionState:function(O){return false
},getDefaultPurchaseAction:function(){return this.hasLink("upgrade")?L.UPGRADE:L.BUY
},getEulaUrl:function(){return this.getLinks().eula
},getHighlights:function(){return this.getVersionDetails()&&this.getVersionDetails().highlights
},getLinkOrPacResponseLink:function(O){return this.getLinks()[O]
},getPricingUrl:function(){return this.getLinkOrPacResponseLink("pricing")
},getScreenshots:function(){return this.getVersionDetails()&&this.getVersionDetails().screenshots
},getVersionDetails:function(){return null
},hasLicense:function(){return !!this.getLicenseDetails()
},hasLink:function(O){return !!(this.getLinks()[O])
},hasRoleBasedPricing:function(){return this.pricingModel&&this.pricingModel.isRoleBased()
},isAtlassianConnect:function(){return false
},isAutoRenew:function(){return this.getLicenseDetails()&&this.getLicenseDetails().autoRenewal
},isInstalled:function(){return false
},isUpm:function(){return this.getKey()===B.getUpmPluginKey()
},isByAtlassian:function(){return this.getVendor()&&(this.getVendor().name==="Atlassian"||this.getVendor().name==="Atlassian Labs")
},isPaidViaAtlassian:function(){return !!this.getUsesLicensing()
},loadInstalledAddonModel:function(){return F.Deferred().resolve(this)
},loadLicenseDetails:function(){var O=this;
if(this.getLicenseDetails()||!this.getLinks().license){return F.Deferred().resolve(this.getLicenseDetails()).promise()
}else{return F.ajax({url:this.getLinks().license}).then(function(P){if(P&&(P.valid||P.error)){O.setLicenseDetails(P,{silent:true});
return O.loadOnDemandBillingNotifications().then(function(Q){if(Q){O.set(Q,{silent:true})
}return P
})
}return P
}).fail(function(P){O.signalAjaxError(P)
}).promise()
}},loadOnDemandBillingNotifications:function(O){var R=this,Q=O?R.clone().clear().set(O):R,P=Q.getLinks()["billing-notifications"];
if(P&&B.isPlatformFreeTier()){return A.ajaxViaBillingProxy({url:P,timeout:5000}).then(function(S){return(S&&S.notifications&&S.notifications.length)?{billingNotifications:S.notifications}:{}
}).promise()
}else{return F.Deferred().resolve({}).promise()
}},loadPricingModel:function(){if(this.pricingModel){return F.Deferred().resolve(this.pricingModel).promise()
}else{var O=this.getPricingUrl(),P=this;
if(O){return F.ajax({type:"get",url:O,dataType:"json"}).then(function(R){var Q=new I(R);
P.pricingModel=Q;
return Q
}).always(F.Deferred().resolve()).promise()
}else{return F.Deferred().resolve().promise()
}}},loadRecommendations:function(){var O=this.getLinks().recommendations;
if(O){return F.ajax({type:"get",cache:false,url:O,dataType:"json"}).then(function(P){return P.recommendations||[]
})
}else{return F.Deferred().resolve([]).promise()
}},loadReviewModel:function(){var O=this.getLinkOrPacResponseLink("plugin-review"),P=this;
if(O){return F.ajax({type:"get",cache:false,url:O,dataType:"json"}).then(function(Q){return new J(M.extend(Q,{addon:P}))
},function(Q){if(Q.status===404){return F.Deferred().resolve(new J({addon:P})).promise()
}else{return Q
}})
}else{return F.Deferred().reject().promise()
}},loadWatchingModel:function(){var O=this.getLinkOrPacResponseLink("plugin-watch"),P=this;
if(O){return F.ajax({type:"get",cache:false,url:O,dataType:"json"}).then(function(Q){return new N(M.extend(Q,{addon:P}))
})
}else{return F.Deferred().reject().promise()
}},logAnalytics:function(P,O){E.logAddonEvent(P,this.getKey(),O)
},refresh:function(){var R=this,Q=this.get("hasDetails"),P=this.getKey(),O=this.getLinks();
this.clear({silent:true});
this.set({key:P,links:{self:O.self}},{silent:true});
if(Q){return this.loadDetails(true).done(function(){R.trigger("change")
})
}else{return this._refreshSummary()
}},_refreshSummary:function(){return this.fetch()
},signalAction:function(O){this.trigger("action",O,this)
},signalAjaxError:function(O){this.trigger("ajaxError",A.parseErrorResponse(O))
},startOnDemandLicenseUpdate:function(O){return F.ajax({url:this.getLinks()[O.legacyKey],type:"POST",contentType:"application/json",headers:{"X-Atlassian-Token":"no-check"}}).promise()
},submitUpdateRequest:function(P,O){return F.ajax({url:this.getLinks()["request-update"],type:"post",contentType:B.getContentType(),dataType:"text",data:JSON.stringify({message:P,pluginKey:this.getKey(),shareDetails:O})}).fail(M.bind(this.signalAjaxError,this)).promise()
},toJSON:function(){return M.extend({},K.Model.prototype.toJSON.apply(this),{atlassianConnect:this.isAtlassianConnect(),installed:this.isInstalled(),paidViaAtlassian:this.isPaidViaAtlassian(),roleBased:this.hasRoleBasedPricing()})
},toPluginRep:function(){return K.Model.prototype.toJSON.apply(this)
},triggerEventAfterExpanding:function(){this.trigger("expandAndThen",arguments)
},triggerMessage:function(O){this.triggerEventAfterExpanding("message",new H(O))
},updateLicense:function(O){var R=M.extend({},this.getLicenseDetails(),{rawLicense:O}),S=O&&(O.trim()!==""),Q=this.toJSON(),P=this;
return F.ajax({type:S?"PUT":"DELETE",url:this.getLinks()["update-license"],contentType:B.getContentType(),data:JSON.stringify(R)}).then(function(T){B.refreshNotifications();
return P.refresh().then(function(){P.triggerEventAfterExpanding("licenseUpdated",Q);
return T
})
},M.bind(this.signalAjaxError,this)).promise()
}})
});